	.include "drivecpu.i"
	
	.importzp part_rootdir
	.importzp dir_c1dcore	; 32-bit start of c1dcore
	.importzp dir_core		; 32-bit start of core
	.importzp dir_deep
	.importzp out_page
	.importzp outptr
	.importzp nameptr
	.importzp mem_page
	.importzp sectorptr
	.importzp tmp_page
	.importzp tmpptr
	.importzp scount
	.importzp vol_fstype
	.importzp file_length
	
ide_read_sector_2buf = $f800
fat_cdroot			 = $f803
fat_read_next_sector = $f806
fat_findfile		 = $f809
fat_loadfile		 = $f80c
mkicon				 = $f80f
	
;	.zeropage
;selected: 	 	.res 1	
;selected_max: 	.res 1	
;dirnr: 	 		.res 1	
;joyA:			.res 1
;joyB:			.res 1
;joyAT:			.res 1
;joyBT:			.res 1
;joyAC:			.res 1
;joyBC:			.res 1

	.segment "EXTCODE"
	jmp confaddon
	jmp menue
ID:	.byte "  --C-ONE C64 ROM Builder v1.01--  22.11.2008"

;;--------------------------------------------
;config addon core
confaddon:
	lda #$10			;reset 1K100 nConfig
	sta $0480   
	
	lda	#0
	sta out_page		;0x00A00 ...
	ldax #$0A00			;select addon config
	stax outptr

	jsr fat_cdroot
	ldax #name_addon	
	jsr fat_findfile
	bcs	confsup
	
	lda #$20			;reset addon nConfig
	sta $0480   
:	adc	#1
	bne	:-
	
	lda #$a0			;set addon nConfig 
	sta $0480
	
	jsr fat_loadfile	; config addon
	
;;--------------------------------------------
;config support core
confsup:
	jsr fat_cdroot
	ldax #name_srbf	
	jsr fat_findfile
	
	php	
	lda #$d0			;set DMA & 1K100 nConfig 
	sta $0480
	plp
	bcs	:+
	
	lda	#0
	sta out_page		;0x00600 ...
	ldax #$0600			;select config
	stax outptr
	jsr fat_loadfile	; config 1K100
	
;;--------------------------------------------
; init 128K Block
:	lda	#5				
	sta out_page
	ldax #$0000			;0x50000 ...
	stax outptr
	ldy #0
:	lda #0
	samy out_page
	iny
	lda #$ff
	samy out_page
	iny
	bne :-
	inc outptr+1
	bne :-
	inc out_page
	lda out_page
	cmp	#7
	bne :-

;load char rom
	jsr fat_cdroot
	lda	#6				
	sta out_page
	ldax #$1000			;0x61000 ...
	stax outptr
	ldax #name_char	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;load char rom
	jsr fat_cdroot
;	lda	#6				
;	sta out_page
	ldax #$9000			;0x69000 ...
	stax outptr
	ldax #name_char	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;load basic rom
:	jsr fat_cdroot
;	lda	#6				
;	sta out_page
	ldax #$A000			;0x6A000 ...
	stax outptr
	ldax #name_basic	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;load char rom
:	jsr fat_cdroot
;	lda	#6				
;	sta out_page
	ldax #$d000			;0x6d000 ...
	stax outptr
	ldax #name_char	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;load kernal rom
:	jsr fat_cdroot
;	lda	#6				
;	sta out_page
	ldax #$E000			;0x6E000 ...
	stax outptr
	ldax #name_kernal	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;;--------------------------------------------
;load ?????????.CRT
:	jsr fat_cdroot
	lda	#4				;$40000
	sta out_page
	ldax #0000
	stax outptr
	ldax #name_crt	
	jsr fat_findfile	;
	bcs	@test_prg
	
	jsr fat_loadfile	;write data to 1K30 dram
;;--------------------------------------------
; copy crt into C64 ROMs
	lda	#4				;$40000
	sta mem_page
	ldax #$004c
	stax sectorptr
	ldy #0
	
	lda	#5				
	sta out_page
	lamy mem_page		;Haddr
	sta outptr+1
	iny
	lamy mem_page		;Laddr
	sta outptr
	iny
	lamy mem_page		;HSize
	tax
	ldy #0
	lda #$50
	sta sectorptr
:	lamy mem_page
	samy out_page
	iny
	bne :-
	inc outptr+1
	inc sectorptr+1
	dex
	bpl :-
	bmi	@mcopy
;;--------------------------------------------
;load ?????????.PRG
@test_prg:
	jsr fat_cdroot
	lda	#4				;$40000
	sta out_page
	ldax #0000
	stax outptr
	ldax #name_prg	
	jsr fat_findfile	;
	bcs	@mcopy
	jsr fat_loadfile	;write data to 1K30 dram
;	
;--------------------------------------------
;get prgstarter
	lda	#5				;$50100-1
	sta out_page
	ldax #$00ff
	stax outptr
	ldy	#prgbinend-prgbin
:	lda prgbin-1,y
	samy out_page
	dey
	bne :-
	jsr	make_sauhund
	
;;--------------------------------------------
; copy 128K Block
@mcopy:
	lda #$40			;reset DMA => start Transfer
	sta $0480 
	lda	#5				
	sta out_page
	ldax #$0000			;0x50000 ...
	stax outptr
	ldy #0
:	lamy out_page
	sta $0600
	iny
	bne :-
	inc outptr+1
	bne :-
	inc out_page
	lda out_page
	cmp	#7
	bne :-
;--------------------------------------------
;config user core
	jsr fat_cdroot
	ldax #name_urbf	
	jsr fat_findfile
	bcs	@runcore
	
	lda #$50			;reset DMA & nConfig
	sta $0480   

:	sbc	#1
	jsr dummyrts
	bne	:-
	
	lda #$90			;set nConfig 
	sta $0480
	lda	#0
	sta out_page		;0x00600 ...
	ldax #$0600			;select config
	stax outptr
	jsr fat_loadfile	; config 1K100
	lda #$01			;screenmode
	sta $0480   
	lda #$82			;screenmode
	sta $0480   
	
;;--------------------------------------------
;start 1K100	
@runcore:	
	lda #$c0			;set DMA and start support core and switch to extern screen
	sta $0480
	
	jsr menue
	
:	beq	:-
	bne :-
	
dummyrts:
	rts
	
make_sauhund:
	jsr fat_cdroot
	ldax #name_prg	
	jsr fat_findfile	;only to get file_length
	
	lda	#6				;patch $6FFFC resetvector
	sta mem_page
	ldax #$FFFC
	stax sectorptr
	ldy #0
	lamy mem_page
	pha					;low
;	lda	#0
	lda	#(basicstart-prgbin+$100)-((basicstart-prgbin+$100)/256*256)
	samy mem_page
	iny
	lamy mem_page
	pha					;high
;	lda #01
	lda	#(basicstart-prgbin+$100)/256
	samy mem_page
	
	lda	#4				;$40000 prg
	sta mem_page
	ldax #$0000
	stax sectorptr
	
	lda	#5				;$50100 starter
	sta out_page
	ldax #$0100
	stax outptr

	ldy #0
	lamy mem_page		;Laddr
	sta tmpptr
	inc sectorptr 
	lamy mem_page		;Haddr
	sta tmpptr+1
	lda #5
	sta tmp_page		;Ladeadresse komplett
;	
; copy PRG into C64 RAM
	sec
	lda file_length
	sbc	#3
	sta file_length
	lda file_length+1
	sbc	#0
	sta file_length+1
@ld:
	inc sectorptr 
	bne	:+
	inc sectorptr+1
:	lamy mem_page
	samy tmp_page
	inc tmpptr
	bne	:+
	inc tmpptr+1
:	lda file_length
	bne :+
	lda file_length+1
	beq	@ready
	dec file_length+1
:	dec file_length
	bne	@ld
	beq	@ld

@ready:
;patchen
	pla					;restore resetvector
	ldy #basicstarter-prgbin+6	;high
	samy out_page
	pla
	ldy #basicstarter-prgbin+1	;low
	samy out_page
	
	lda tmpptr			;Lend
;	ldy #$6b
	ldy #basicstarter_second-prgbin+1
	samy out_page
	iny
	iny
	lda tmpptr+1		;Hend
	samy out_page
	
	lda	#5				;$050801 prg
	sta mem_page
	ldax #$0801
	stax sectorptr
	ldy #$00
	lamy mem_page
;	ldy #$8c
	ldy #basicstarter_second_2-prgbin+1
	samy out_page
	ldy #$01
	lamy mem_page
;	ldy #$8e
	ldy #basicstarter_second_2-prgbin+3
	samy out_page
	rts

prgbin:
;	.incbin "prgstarter.bin"
;   Thanks Gropaz
;-------------------------------------------------------------------------------------------------------------
;	.org $0100
	jsr $fda3	; Initialise I/O (needs $02a6 pal/ntsc set)

	;JSR $FD50	; Initialise System Constants
			
	LDA #$00
	TAY
llp2:
	STA $0002,Y
	STA $0200,Y
	STA $0300,Y
	INY
	BNE llp2
			
	LDX #$3C
	LDY #$03
	STX $B2       ; Pointer: Start Address of Tape Buffer
	STY $B3       ; Pointer: Start Address of Tape Buffer

	ldx #$00
	ldy #$a0
	sty $c2
	clc
	jsr $fe2d
;FD88: 98        TYA
;FD89: AA        TAX
;FD8A: A4 C2     LDY $C2       ; Start Address for LOAD and Cassette Write
;FD8C: 18        CLC
;FD8D: 20 2D FE  JSR $FE2D     ; Read / Set Top of Memory
;FD90: A9 08     LDA #$08
;FD92: 8D 82 02  STA $0282     ; Pointer: Bottom of Memory for Operating System
;FD95: A9 04     LDA #$04
;FD97: 8D 88 02  STA $0288     ; High Byte of Screen Memory Address
;FD9A: 60        RTS						
	lda #$08
	sta $0282	; (hi) Pointer: Bottom of Memory for Operating System
	lda #$04
	sta $0288	; High Byte of Screen Memory Address

	JSR $FD15     ; Restore Kernal Vectors
	JSR $FF5B     ; Initialize screen editor

	; put "sY362" into keyboard buffer
	lda #83  ;s
	sta $0277
	lda #217 ;Y
	sta $0277+1
;	lda #48+3
	lda #48+((basicstarter_second-prgbin+$100)/100)
	sta $0277+2
;	lda #48+6
	lda #48+((basicstarter_second-prgbin+$100)/10)-((basicstarter_second-prgbin+$100)/100*10)
	sta $0277+3
;	lda #48+2
	lda #48+(basicstarter_second-prgbin+$100)-((basicstarter_second-prgbin+$100)/10*10)
	sta $0277+4
			
	lda #13
	sta $0277+5
	lda #$06
	sta $c6	

	ldx #$ff
	txs
	cli

	JMP ($A000)   ; Start BASIC
			
basicstarter_second:

	ldx #0			; <-- lowbyte letzte addresse	($016b)
	ldy #0			; <-- highbyte letzte addresse	($016d)
			
	stx $2d	; 45 (lo) Pointer: Start of BASIC Variables
	stx $2f ; 47 (lo) Pointer: Start of BASIC Arrays
	stx $31 ; 49 (lo) Pointer: End of BASIC Arrays + 1
	stx $ae ; 174(lo) Tape End Address/End of Program

	sty $2e	; 46 (hi)
	sty $30 ; 48 (hi)
	sty $32 ; 50 (hi)
	sty $af ; 175(hi)

	; Utility String Pointer
	lda #$00
	sta $35	;53
	lda #$a0
	sta $36	;54

	lda #0
	sta $0800
			
basicstarter_second_2:

	ldx #0			; <-- wert aus $0801	($018c)
	ldy #0			; <-- wert aus $0802	($018e)
	stx $0801
	sty $0802

	lda #%01111101		;prepare keyboard for keycheck
	sta $dc00

	; check commodore key
	lda $dc01
	and #%00100000
	beq @noautostart						

	; put "rU" into keyboard buffer
	lda #82  ;r
	sta $0277
	lda #213 ;U
	sta $0277+1
	lda #13
	sta $0277+2
	lda #$03
	sta $c6	

@noautostart:
	lda $dc0d
	lda $dd0d
	inc $d019
	cli
	rts
	
	

basicstart:
	jmp basicstarter-prgbin+$100
	
basicstarter:
; $FCE2/64738:   Power-Up RESET Entry
; 
; FCE2: A2 FF     LDX #$FF
; FCE4: 78        SEI
; FCE5: 9A        TXS
; FCE6: D8        CLD
; FCE7: 20 02 FD  JSR $FD02     ; Check For 8-ROM
;
;	FD02: A2 05     LDX #$05
;
;	Jump from $FD0D:
;
;	FD04: BD 0F FD  LDA $FD0F,X
;	FD07: DD 03 80  CMP $8003,X
;	FD0A: D0 03     BNE $FD0F
;	FD0C: CA        DEX
;	FD0D: D0 F5     BNE $FD04
;
;	Jump from $FD0A:
;
;	FD0F: 60        RTS			
;			
; FCEA: D0 03     BNE $FCEF
; FCEC: 6C 00 80  JMP ($8000)
; 
; Jump from $FCEA:
; 
; FCEF: 8E 16 D0  STX $D016     ; VIC: Control Register 2
; FCF2: 20 A3 FD  JSR $FDA3     ; Initialise I/O
; FCF5: 20 50 FD  JSR $FD50     ; Initialise System Constants
; FCF8: 20 15 FD  JSR $FD15     ; Restore Kernal Vectors
; FCFB: 20 5B FF  JSR $FF5B     ; Initialize screen editor
; FCFE: 58        CLI
; FCFF: 6C 00 A0  JMP ($A000)   ; Restart Vectors
					
	lda #$0	;low
;	sta $101
	sta basicstart-prgbin+$101
	lda #$0	;high
;	sta $102
	sta basicstart-prgbin+$102
	sei

	lda #$2f
	sta $00
	lda #$37
	sta $01

	ldx #$ff
	txs
	cld
			
	jmp $100
	
prgbinend:
	 
;use only big letters!
name_srbf:
	.byte "SUPPORT RBF"
name_urbf:
	.byte "TARGET  RBF"
name_addon:
	.byte "EXTENDERRBF"
name_crt:
	.byte "????????CRT"
name_prg:
	.byte "????????PRG"
name_kernal:
	.byte "KERNAL  ROM"
name_basic:
	.byte "BASIC   ROM"
name_char:
	.byte "CHAR    ROM"

menue:
	lda	$0403			;wait for key
	and	#$2
	bne	menue
	lda $0402			; read scancode
	cmp #$78			;F11
	bne menue
	lda #$83			;screenmode
	sta $0480   
menue2:
	lda	$0403			;wait for key
	and	#$2
	bne	menue2
	lda $0402			; read scancode
	cmp #$76			;ESC
	bne menue2
	lda #$01			;screenmode
	sta $0480   
	bne menue

