	.include "drivecpu.i"

	.export reseth
	.export warmstart

	.export mkicon
 
	.importzp lba
	.importzp dir_deep
	
	.importzp mem_page
	.importzp sectorptr
	.importzp nameptr
	.importzp out_page
	.importzp outptr
	.importzp tmp_page
	.importzp tmpptr
	 
	.import fat_dir_first, fat_dir_next
	.import fat_cdroot
	.import fat_cdc1dcores
	.import fat_next_clust
	.import fat_findfile
	.import fat_loadfile
	.importzp vol_fstype
	.importzp part_cstart
	.importzp vol_secperclus
	.importzp cluster
	.importzp part_num


	.import ide_read_sector
	.import ide_read_sector_2buf
	.import ide_init
	.import idecache_valid	
	
	.importzp devtype_none
	.importzp devtype_hd
	.importzp devtype_cd
	
	.importzp part_rootdirstart

find_volume = $4b
fat_read_volid = $48 
	.zeropage

boot_exist:		.res 1	
;image_exist:	.res 1	
config_exist:	.res 1	

	.code		; at $F800

reseth:
	sei
	cld
	ldx #$ff
	txs

warmstart:
	
	lda	#2
	jsr ide_init
	bcc @partition
	
	lda	#3
	jsr ide_init
	bcc @partition
	
	lda	#0
	jsr ide_init
	bcc @partition
	
	lda	#1
	jsr ide_init
	bcc @partition
	
	;nichts gefunden
@error:
	sec
:	beq	:-
	bne :-
	
	
@partition:	
	lda vol_fstype
	cmp #$ff
	bne reconfig
	
	jsr find_volume
	bcs @error
	jsr fat_read_volid
	bcs @error
subcluster:
	ldx #2			; subtract two clusters to compensate
:	sec			; for reserved values 0 and 1
	lda part_cstart
	sbc vol_secperclus
	sta part_cstart
	lda part_cstart+1
	sbc #0
	sta part_cstart+1
	lda part_cstart+2
	sbc #0
	sta part_cstart+2
	lda part_cstart+3
	sbc #0
	sta part_cstart+3
	dex
	bne :-
;;--------------------------------------------
init_done:
	lda #0
	sta dir_deep
	
;;--------------------------------------------
;load boot program
reconfig:
	lda #0
	sta boot_exist
	sta config_exist
;		lda dir_deep
;		sta $800
	
	jsr fat_cdroot
	ldax #name_bbin		;boot.bin
	jsr fat_findfile	;search file
	bcs	confaddon		;found?
	
;		lda #$bb
;		sta $800
;		lda vol_fstype
;		sta $800
	lda	#0
	sta out_page		
	ldax #$2000			;0x02000 ...
	stax outptr
	jsr fat_loadfile	;write data to dram
	lda #$ff
	sta boot_exist
;		lda #'>'
;		sta $800
	jsr $2000
;:		lda #'+'
;		sta $800
	
;;--------------------------------------------
;config addon core
confaddon:
;	lda #$10			;reset 1K100 nConfig/disable Video, reset DMA
	lda #$50			;reset 1K100 nConfig/disable Video
	sta $0480   
	
	lda	#0
	sta out_page		;0x00A00 ...
	ldax #$0A00			;select addon config
	stax outptr

	jsr fat_cdroot
	ldax #name_addon	
	jsr fat_findfile
;	php
	bcs	confsup
	
;	lda #$30			;reset addon nConfig and 1K100 nConfig
	lda #$20			;reset addon nConfig
	sta $0480   
:	adc	#1
	bne	:-
	
	lda #$a0			;set addon nConfig 
	sta $0480
	
;	plp
;	bcs	confsup

;	lda	#0
;	sta out_page		;0x00A00 ...
;	ldax #$0A00			;select addon config
;	stax outptr
	jsr fat_loadfile	; config addon
	
;;--------------------------------------------
;config support core
confsup:
;	lda #$10			;reset 1K100 nConfig
;	sta $0480   
	jsr fat_cdroot
	
	lda cluster+3
	pha
	lda cluster+2
	pha
	lda cluster+1
	pha
	lda cluster
	pha
	
	lda #$55
	sta idecache_valid
	
	ldax #name_srbf	
	jsr fat_findfile
	php	
	pla
	tax
	
	lda #$c0			;set DMA -> enable mdb(0) 
	sta $0480
	
; copy Partitionsdata to addon	
	lda part_num
	sec
	rol a
	samy out_page
	ldy	#4
:	pla
	samy out_page
	dey  
	bne	:-
	txa
	pha
	
	lda #$d0			;set DMA & 1K100 nConfig 
	sta $0480
	plp
	bcs	:+
	
	lda #$ff
	sta config_exist
	lda	#0
	sta out_page		;0x00600 ...
	ldax #$0600			;select config
;	ldax #$0800			;select config
	stax outptr
	jsr fat_loadfile	; config 1K100
	
;;--------------------------------------------
;load start bin
:	jsr fat_cdroot
	lda	#8				;$80000
	sta out_page
	ldax #0000
	stax outptr
	ldax #name_start	
	jsr fat_findfile	;
	bcs	:+
	
	jsr fat_loadfile	;write data to 1K30 dram
	
;;--------------------------------------------
;load support bin
:	lda config_exist
	beq	:+  
	lda #$40			;reset DMA => start Transfer
	sta $0480 
	jsr fat_cdroot
	lda	#0				
	sta out_page
	ldax #$0600			;0x00600 ...
	stax outptr
	ldax #name_srom	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;;--------------------------------------------
;--------------------------------------------
;config user core
:	jsr fat_cdroot
	ldax #name_urbf	
	stax nameptr
	jsr fat_findfile
	bcs	@runcore
	
;	lda	$0403
;	and	#$2
;	bne	:+
;	lda $0402			; read scancode
;
;	and #$7f
;	cmp #$29			;SPACE?
;	beq	@runcore
	
:	lda #$50			;reset DMA & nConfig
	sta $0480   

:	sbc	#1
	jsr dummyrts
	bne	:-
	
	lda #$90			;set nConfig 
	sta $0480
	lda	#0
	sta out_page		;0x00600 ...
	ldax #$0600			;select config
	stax outptr
	jsr fat_loadfile	; config 1K100
	lda #$01			;screenmode
	sta $0480   
	lda #$82			;screenmode
	sta $0480   
	
;;--------------------------------------------
;start 1K100	
;:	lda image_exist
;	beq	:+
;	jsr	pauseimage
@runcore:	
	lda	#3
	sta $0403			;disable IEC
;:	lda config_exist
;	beq	:+  
;	lda #$8a			;set DMA and start support core and switch to extern screen
	lda #$c0			;set DMA and start support core and switch to extern screen
;	lda #$9e			;set DMA and start support core and switch to extern screen
	sta $0480
	
	lda boot_exist
	beq	freeze
	jsr $2003
	
;	lda #$01			;screenmode
;	sta $0480   
;	lda #$82			;screenmode
;	sta $0480   
	jmp reconfig
freeze:	
	sta $04C0			;freeze System
	
;:	beq	:-
;	bne :-

	
	 
;use only big letters!
name_bbin:
	.byte "BOOT    BIN"		;load and start at $2000 if existing
name_srbf:
	.byte "SUPPORT RBF"
name_srom:
	.byte "SUPPORT BIN"
name_start:
	.byte "EMU     BIN"		;load at $80000 to use after reconfig 1K30
name_urbf:
	.byte "TARGET  RBF"
name_addon:
	.byte "EXTENDERRBF"

	

;only to speedup menue
mkicon:	
	bne mkselect
@mkicon1:	
	lamy mem_page
	beq :+
	samy out_page
:	iny
	cpy #160
	bne @mkicon1
dummyrts:
	rts
	
mkselect:	
	lamy mem_page
	beq :+
	lamy tmp_page
	pha
	lamy out_page
	samy tmp_page
	pla
	samy out_page
	
:	iny
	cpy #160
	bne mkselect
	rts
