fs_fat12	= $12
fs_fat16	= $16
fs_fat32	= $32

sectorbuf	= $200


; CPU speed in MHz
cpuspeed	= 2


; --- Flash ROM ---

flash_clear	= $00
flash_shift	= $04
flash_inc	= $08
flash_data	= $0c


; --- device map ---

dev_roml	= $f0
dev_io2		= $f1
dev_clk1	= $f2
dev_sid1	= $f3
dev_romh	= $f4
dev_io1		= $f5
dev_clk2	= $f6
dev_sid2	= $f7
dev_sregbuf	= $f8
dev_pdata	= $f9
dev_pddr	= $fa
dev_serial	= $fb
dev_pcigrntres	= $fc
dev_pci0grntset	= $fd
dev_pci1grntset	= $fe
dev_release	= $ff


; --- RS-232 ---

A16550BASE	= $3f20





; load accumulator indirect from memory
	.macro lamy ptraddr
	.byte $b2, <ptraddr
	.endmacro

; store accumulator indirect from memory
	.macro samy ptraddr
	.byte $92, <ptraddr
	.endmacro


; --- misc ---
	.macro ldax arg
	.if (.match (.left (1, {arg}), #))	; immediate mode
	lda #<(.right (.tcount ({arg})-1, {arg}))
	ldx #>(.right (.tcount ({arg})-1, {arg}))
	.else					; assume absolute or zero page
	lda arg
	ldx 1 + (arg)
	.endif
	.endmacro

	.macro stax dest
	sta dest
	stx dest+1
	.endmacro


; --- RS-232 Debugging ---

; print a string
	.macro dputs string
	php
	pha
	txa
	pha
	lda #<string
	ldx #>string
	jsr debug_puts
	pla
	tax
	pla
	plp
	.endmacro

; print a number in A
	.macro dputnum
	php
	pha
	jsr debug_puthex
	pla
	plp
	.endmacro

; print a digit in A
	.macro dputdigit
	php
	pha
	jsr debug_putdigit
	pla
	plp
	.endmacro

; print a character in A
	.macro dputc
	php
	pha
	jsr debug_put
	pla
	plp
	.endmacro

; print cr+lf
	.macro dputcrlf
	php
	pha
	jsr debug_crlf
	pla
	plp
	.endmacro

; print 32-bit number
	.macro dputnum32 address
	php
	pha
	lda address+3
	jsr debug_puthex
	lda address+2
	jsr debug_puthex
	lda address+1
	jsr debug_puthex
	lda address
	jsr debug_puthex
	pla
	plp
	.endmacro
