	.include "drivecpu.i"
	
	.importzp part_rootdir
	.importzp dir_c1dcore	; 32-bit start of c1dcore
	.importzp dir_core		; 32-bit start of core
	.importzp dir_deep
	.importzp out_page
	.importzp outptr
	.importzp nameptr
	.importzp mem_page
	.importzp sectorptr
	.importzp tmp_page
	.importzp tmpptr
	.importzp scount
	.importzp vol_fstype
	.importzp cluster		;tmp for name
	
ide_read_sector_2buf = $f800
fat_cdroot			 = $f803
fat_read_next_sector = $f806
fat_findfile		 = $f809
fat_loadfile		 = $f80c
mkicon				 = $f80f
	
	.zeropage
selected: 	 	.res 1	
selected_max: 	.res 1	
dirnr: 	 		.res 1	
joyA:			.res 1
joyB:			.res 1
joyAT:			.res 1
joyBT:			.res 1
joyAC:			.res 1
joyBC:			.res 1

	.segment "EXTCODE"
	jmp screen_init
	jmp menue
ID:	.byte "  --C-ONE Selector V1.1--  14.11.2008"

	
icon_copy:
	lda	#$02
	sta mem_page		;0x18000 ...
	lda	#$01
	sta tmp_page		;0x28000 ...
	ldax #$8000
	stax sectorptr
	stax tmpptr
	ldx #0
icon_copy1:
	ldy #0
:	lamy mem_page
	samy tmp_page
	iny
	cpy #160
	bne :-
	
	clc
	lda sectorptr
	adc #160
	sta sectorptr
	sta tmpptr
	bcc :+
	inc sectorptr+1
	inc tmpptr+1
	bne :+
	inc mem_page
	inc tmp_page

:	inx
	cpx #160
	bne icon_copy1
	rts

icon_clear:
	lda	#$01
	sta tmp_page		;0x28000 ...
	ldax #$8000
	stax tmpptr
	ldx #0
icon_clear1:
	ldy #0
	tya
:	samy tmp_page
	iny
	samy tmp_page
	iny
	samy tmp_page
	iny
	samy tmp_page
	iny
	cpy #160
	bne :-
	
	clc
	lda tmpptr
	adc #160
	sta tmpptr
	bcc :+
	inc tmpptr+1
	bne :+
	inc tmp_page

:	inx
	cpx #160
	bne icon_clear1
	rts







icon:
	lda #0
	beq :+
select:
	lda #1
:	php

; y: iconnr
	lda	#$08
	sta out_page		;0x80000 ...
	ldax #$0000
	stax outptr
:	cpy #4
	bcc :+
	clc
	lda outptr+1
	adc #$90
	sta outptr+1
	lda out_page
	adc #$01
	sta out_page
	tya
	sec
	sbc #4
	tay
	bcs :-
	
:	dey
    bmi :+
	clc
	lda outptr
	adc #160
	sta outptr
	bcc :-
	inc outptr+1
	bne :-
	inc out_page
	bne :-
	
:	lda	#$01
	sta mem_page		;0x18000 ...
	lda	#$02
	sta tmp_page		;0x28000 ...
	ldax #$8000
	stax sectorptr
	stax tmpptr
	
	ldx #0
select1:	
	ldy	#0
	plp
	php
	jsr	mkicon
	
	clc
	lda sectorptr
	adc #160
	sta sectorptr
	sta tmpptr
	bcc :+
	inc sectorptr+1
	inc tmpptr+1
	bne :+
	inc mem_page
	inc tmp_page

:	clc
	lda outptr
	adc #$80
	sta outptr
	lda outptr+1
	adc #$2
	sta outptr+1
	bcc :+
	inc out_page
	
:	inx
	cpx #160
	bne select1
	plp
	rts

	
;--------------------------------------------
screen_init:
;			lda #'s'
;			sta $0800
; init Joystick
	lda #$ff
	sta joyA
	sta joyB
; init keyboard	
	lda $0402			
; init Screen
;   0  10000  7BA00
; -27  100D8  7FD80

;  28  100E0  80000  2,1
;-507  10FD8  CAD80

; 508  10FE0  CB000
;-521  11048  CD080

; 522  11050  CD300 7
; 523  11058  CD580 7
; 524  11060  CD800 7,6
	lda	#$10
	sta $440			;set screenbase to 0x10000		
	lda	#1
	sta out_page		
	ldax #$0000			;0x010000 ...
	stax outptr
	lda	#0
	sta mem_page
	lda	#$ba
	sta mem_page+1
	lda	#$07
	sta mem_page+2
@nline:	
	ldy	#0
	lda mem_page
	samy out_page
	iny
	lda mem_page+1
	samy out_page
	tax
	iny
	lda mem_page+2
	samy out_page
	iny
	
	cmp	#$7
	beq	@null
	cmp	#$c
	bne	@disp
	
	cpx	#$b0
	bcc @disp
	
	lda	#$40
	cpx #$d8	;
	beq	:+
	lda	#$00	;vsync
	cpx #$d3
	bcs :+
@null:	
	lda	#$80
	bne	:+
@disp:	
;	lda	#$86	;16 bit
	lda	#$82	; 8 bit
:	samy out_page

	clc
	lda mem_page
	adc	#$40
	sta mem_page
	lda mem_page+1
	adc	#$01
	sta mem_page+1
	bcc	:+
	inc mem_page+2
	
:	clc
	lda	outptr
	adc	#4
	sta outptr
	bcc	@nline
	inc	outptr+1
	lda outptr+1
	cmp	#$20
	bne	@nline
	
	lda #$81			;set mode
	sta $0480
	lda #$02			;intern screen
	sta $0480
	
;--------------------------------------------
;load boot screen
lbscreen:
	jsr fat_cdroot
	ldax #name_bimg		;selectbg.raw
	jsr fat_findfile	;search file
	bcs	:+				;found?
	
;			lda #'b'
;			sta $0800
	lda	#08
	sta out_page		;0x80000 ...
	ldax #$0000
	stax outptr
	jsr fat_loadfile	;write data to dram
	
;--------------------------------------------
;load test icon
:	jsr fat_cdroot
	ldax #name_select	;select.raw
	jsr fat_findfile	;search file
	bcs	:+				;found?
	
;			lda #'i'
;			sta $0800
	lda	#02
	sta out_page		;0x28000 ...
	ldax #$8000
	stax outptr
	jsr fat_loadfile	;write data to dram
	
:
	ldx #0
:	lda 0,x
	sta $1000,x
	inx
	bne	:-
	rts	
	
name_bimg:
	.byte "SELECTBGRAW"		;load at $80000 and shown as 640x480x8 picture
name_icon:
	.byte "SELECT  RAW"		;load at $18000 and shown as 160x160x8 picture
name_select:
	.byte "MARKER  RAW"		;load at $28000 and shown as 160x160x8 picture
name_crt:
	.byte "????????CRT"
name_prg:
	.byte "????????PRG"
name_selecttxt:
	.byte "SELECT  TXT"
	
;--------------------------------------------
menue:	
	jsr fat_cdc1dcores	
	lda	#1
@menue1:	
	pha
	jsr fat_cdcores		;inc dir_deep in SBR
	bcs @menue2
	jsr fat_cdroot
	dec dir_deep
	ldax #name_icon		;select.raw
	jsr fat_findfile	;search file
	bcs	:+				;found?
	
;		lda #'+'
;		sta $0800
	lda	#01
	sta out_page		;0x18000 ...
	ldax #$8000
	stax outptr
	jsr fat_loadfile	;write data to dram
	jmp	@menue3
;--------------------------------------------
;delete icon? 
:	jsr icon_clear
@menue3:
	inc dir_deep
	jsr fat_cdroot
	dec dir_deep
	ldax #name_selecttxt		;select.txt
	jsr fat_findfile	;search file
;	bcs	@menue4				;found?
	bcs	:+				;found?
	
;		lda #'+'
;		sta $0800
	lda	#02
	sta out_page		;0x20000 ...
	ldax #$0000
	stax outptr
	jsr fat_loadfile	;write data to dram
	jsr selectname
	jmp	@menue4
;--------------------------------------------
:	jsr make_crtname
	bcc	@menue4		

;--------------------------------------------
;@search_prg:
	jsr make_prgname
;	bcs	@menue4		
	
;--------------------------------------------
	
@menue4:	
	pla
	pha
	tay
	dey
	jsr icon
	
	pla
	clc
	adc	#1
	cmp #13
	bne @menue1
	beq :+

@menue2:
	dec dir_deep
	pla
;		sta $800
:	sec
	sbc #1
:	bmi :-	;stop no core exist
;		sta $800
	sta selected_max
	lsr
;		sta $800
	sta selected
	jsr icon_copy
	ldy selected
	jmp key_loop2

make_crtname:
	inc dir_deep
	jsr fat_cdroot
	dec dir_deep
	ldax #name_crt		;?????????.CRT
	jsr fat_findfile	;search file
	bcs	@rts			;found?
	
;		lda #'+'
;		sta $0800
	lda	#02
	sta out_page		;0x20000 ...
	ldax #$0000
	stax outptr
	jsr fat_loadfile	;write data to dram
	jsr crtname
	clc
@rts:	
	rts
	
make_prgname:
	inc dir_deep
	jsr fat_cdroot
	dec dir_deep
	ldax #name_prg		;?????????.PRG
	jsr fat_findfile	;search file
	bcs	@rts		
			;found?
	
;		lda #'+'
;		sta $0800
	lda	#02
	sta out_page		;0x20000 ...
	ldax #$0020
	stax outptr
	ldy #0
:	lda (sectorptr),y
	samy out_page	;write data to dram
	iny
	cpy	#8
	bne :-
	lda #'.'
	samy out_page	;write data to dram
	inc outptr
:	lda (sectorptr),y
	samy out_page	;write data to dram
	iny
	cpy	#11
	bne :-
	lda #0
	samy out_page	;write data to dram
	jsr crtname
	clc
@rts:	
	rts
	
key_loop:
	clc
	adc selected
	bmi key_loop1
;	bpl :+
;	clc
;	adc selected_max
;:
	cmp selected_max 
	bcs key_loop1
;	bcc :+
;	sbc selected_max
;:
	pha
	ldy selected
	jsr select
	pla
	
	sta selected
	tay
key_loop2:	
	jsr select
key_loop1:
	lda #$c0
	ora $0400			;joyA
	cmp joyAT
	beq :+
	sta joyAT
	lda #$ff
	sta joyAC
:	dec joyAC
	bne :+

	lda joyA
	pha
	lda joyAT			;joyA
	sta joyA
	pla
	eor joyA
	and joyA
	and #$3f
	bne @joyakt

:	lda #$c0
	ora $0401			;joyB
	cmp joyBT
	beq :+
	sta joyBT
	lda #$ff
	sta joyBC
:	dec joyBC
	bne @keyakt

	lda joyB
	pha
	lda joyBT			;joyB
	sta joyB
	pla
	eor joyB
	and joyB
	
@joyakt:
	lsr a
	bcc :+				;up?
	lda	#-4
	bcs	key_loop

:	lsr a
	bcc :+				;down?
	lda	#4
	bcs	key_loop

:	lsr a
	bcc :+				;LEFT?
	lda	#-1
	bcs	key_loop

:	lsr a
	bcc :+				;Rigth?
	lda	#1
	bcs	key_loop

:	lsr a
	bcs @enter			;Fire?
	lsr a
	bcs @enter			;Fire?

@keyakt:
	lda	$0403			;wait for key
	and	#$2
	bne	key_loop1
	lda $0402			; read scancode

	cmp #$6B			;LEFT?
	bne	:+
	lda	#-1
	bne	@key_loop3
	
:	cmp #$74			;Rigth?
	bne	:+
	lda	#1
	bne	@key_loop3

:	cmp #$75			;up?
	bne	:+
	lda	#-4
	bne	@key_loop3

:	cmp #$72			;down?
	bne	:+
	lda	#4
	bne	@key_loop3

:	cmp #$76			;ESC?
	bne	:+
	jmp	@dirback

:	cmp #$5a			;Enter?
	beq @enter	
@key_loop1a:
	jmp key_loop1
@key_loop3:
	jmp key_loop
	
@enter:	
	ldy selected
	jsr select
	lda selected
	clc
	adc #1
	jsr fat_cdcores
	
	ldx #0
:	lda 0,x
	sta $1000,x
	inx
	bne	:-
	
	lda #$03			;screenmode
	sta $0480   
;	lda #$01			;screenmode
;	sta $0480   
;	lda #$82			;screenmode
;	sta $0480   
	rts
	
@dirback:
	lda dir_deep
	cmp #1
	beq @key_loop1a
	jsr fat_cdroot			;first in c1dcores
	jsr ide_read_sector_2buf	; load dir sector into buffer
@key_loop3a:	
	bcs @key_loop1a
	ldax #sectorbuf	; load data into sectorbuf
	stax sectorptr
@db_m1:	
	ldy	#0
	lda (sectorptr),y
	cmp	#'.'
@key_loop3b:	
	bne	@key_loop1a
	iny
	lda (sectorptr),y
	cmp	#'.'
	beq :+
	lda sectorptr
	clc
	adc #$20
	sta sectorptr
	bne	@db_m1

:	;c1dcore dir found
	jsr founddir	;get core cluster 
	
	dec dir_deep
	jsr fat_cdroot
	inc dir_deep
	jsr ide_read_sector_2buf	; load dir sector into buffer
	bcs @key_loop3a
	ldax #sectorbuf	; load data into sectorbuf
	stax sectorptr
@db_m2:	
	ldy	#0
	lda (sectorptr),y
	cmp	#'.'
	bne	@key_loop3b
	iny
	lda (sectorptr),y
	cmp	#'.'
	beq :+
	lda sectorptr
	clc
	adc #$20
	sta sectorptr
	bne	@db_m2
	
:	jsr founddir_dc	;get dc cluster 
	
	jsr fat_cdroot
	jsr ide_read_sector_2buf	; load dir sector into buffer
	bcs @key_loop3a
	ldax #sectorbuf	; load data into sectorbuf
	stax sectorptr
@db_m3:	
	ldy	#0
	lda (sectorptr),y
	cmp	#'.'
	bne	@key_loop3b
	iny
	lda (sectorptr),y
	cmp	#'.'
	beq :+
	lda sectorptr
	clc
	adc #$20
	sta sectorptr
	bne	@db_m3

:	;c1dcore dir found
	jsr founddir	;get core cluster 
	dec dir_deep
	dec dir_deep
	dec dir_deep
	
	lda #$03			;screenmode
	sta $0480   
	rts
	
; change directory
; needs the first cluster of the current dir in cluster
; and the name of the dir to change to in nameptr
; returns the new dir address in cluster or carry set on error
fat_cdc1dcores:
	jsr fat_cdroot
	ldax #bootdirname
	stax nameptr
	jsr ide_read_sector_2buf	; load dir sector into buffer
	bcs @error

@checksector:	
	ldax #sectorbuf	; load data into sectorbuf
	stax sectorptr
	
@checkentry:
	ldy #11			; check entry type
	lda (sectorptr),y
	and #$10
	beq @skip
	
	ldy #0			
	lda (sectorptr),y
	beq @lastentry

@next_char:	
	sec
	lda (sectorptr),y
	sbc (nameptr),y
	beq	:+
	cmp #$20
	bne @skip
:	
	iny
	cpy #11;namelen
	bne @next_char
	beq @founddir

@skip:	
	lda sectorptr
	clc
	adc #$20
	sta sectorptr
	bcc @checkentry
	inc sectorptr+1
	lda sectorptr+1
	and #1				;stop at $04
	bne @checkentry
	
	lda	scount
	cmp #1
	bne	:+
	
:	jsr fat_read_next_sector
	bcc @checksector		; premature end of dir
	
@lastentry:

;	rts
@error:
	sec
	rts
	
	
@founddir:
	inc dir_deep
founddir_dc:
	lda #0
	sta dir_c1dcore+2
	sta dir_c1dcore+3
	ldy #$1a		; we found the directory, new cluster
	lda (sectorptr),y		; address
	sta dir_c1dcore
	iny
	lda (sectorptr),y
	sta dir_c1dcore+1

	lda vol_fstype
	cmp #fs_fat32
	bne @fat16or12

	ldy #$14
	lda (sectorptr),y
	sta dir_c1dcore+2
	iny
	lda (sectorptr),y
	sta dir_c1dcore+3
@fat16or12:
	clc
	rts

bootdirname:
	.byte "C1DCORES","   "
	
; change directory
; needs the first cluster of the current dir in cluster
; and the name of the dir to change to in nameptr
; returns the new dir address in cluster or carry set on error
fat_cdcores:
	sta dirnr
	jsr fat_cdroot
	inc dir_deep
	jsr ide_read_sector_2buf	; load dir sector into buffer
	bcs @error
@checksector:	
	ldax #sectorbuf	; load data into sectorbuf
	stax sectorptr
	
@checkentry:
	ldy #11			; check entry type
	lda (sectorptr),y
	and #$10
	beq @skip
	
	ldy #0			
	lda (sectorptr),y
	beq @lastentry
	cmp #$e5
	beq @skip
	cmp #$2e
	beq @skip 
	
	dec dirnr
	beq founddir
	
@skip:	
	lda sectorptr
	clc
	adc #$20
	sta sectorptr
	bcc @checkentry
	inc sectorptr+1
	lda sectorptr+1
	and #1				;stop at $04
	bne @checkentry
	
;	lda	scount
;	cmp #1
;	bne	:+
;	
;:
	jsr fat_read_next_sector
	bcc @checksector		; premature end of dir
	
@lastentry:

;	rts
@error:
	sec
	rts
	
	
founddir:
;@next_char:	
;	sec
;	lda (sectorptr),y
;	sta $800
;	iny
;	cpy #11;namelen
;	bne @next_char
	
;		lda	#$0d
;		sta $800
;		lda	#$0a
;		sta $800


	lda #0
	sta dir_core+2
	sta dir_core+3
	ldy #$1a		; we found the directory, new cluster
	lda (sectorptr),y		; address
	sta dir_core
	iny
	lda (sectorptr),y
	sta dir_core+1

	lda vol_fstype
	cmp #fs_fat32
	bne @fat16or12

	ldy #$14
	lda (sectorptr),y
	sta dir_core+2
	iny
	lda (sectorptr),y
	sta dir_core+3
@fat16or12:
	clc
	rts



; plot character at current position
gfx_plotchar:
	cmp	#' '
	bne @gfx_p1
	clc
	lda outptr
	adc #$8
	sta outptr
	bcc :+
	inc outptr+1
	beq :+
	inc out_page
:	rts
	
@gfx_p1:	
	pha
	ldax #bootfont
	stax tmpptr
	pla
	pha
	and #$60
	lsr
	lsr
	lsr
	lsr
	lsr
	adc tmpptr+1
	sta tmpptr+1
	pla
	and #$1f
	asl
	asl
	asl
	
	tay
	pha
gfx_plotchar1:	
	ldx	#2
	lda (tmpptr),y
gfx_plotchar2:
	pha
	ldy #0
gfx_plotchar3:
	asl
	bcc :+
	pha
	lda #$1
	samy out_page
	pla
:   iny
	cpy #8
	bne gfx_plotchar3
	
	clc
	lda outptr
	adc #160
	sta outptr
	bcc :+
	inc outptr+1
	bne :+
	inc out_page
	
:	pla
	dex
	bne gfx_plotchar2

	clc
	pla
	adc #1
	tay
	pha
	and #7
	bne gfx_plotchar1
	pla
	
	sec
	lda outptr
;	sbc #$e8
	sbc #$f8
	sta outptr
	lda outptr+1
	sbc #$9
	sta outptr+1
	bcs :+
	dec out_page
:	
	rts

crtname:
	lda  #1
	pha
	ldax #$8144-$960+(8*$AA0)
	stax cluster
	ldax #$0020
	jmp :+
	
selectname:
;file_length
;	rts
	lda  #9
	pha
	ldax #$8144-$960
	stax cluster
	ldax #$0000
	
:	stax sectorptr
	lda	#01
	sta cluster+2		;0x18000 ...
	lda	#02
	sta mem_page		;0x20000 ...
	pla
crtn_m0:
	pha
	clc
	lda cluster
	adc	#$A0
	sta cluster
	sta outptr
	lda cluster+1
	adc	#$0A
	sta cluster+1
	sta outptr+1
	lda cluster+2
	adc	#$00
	sta cluster+2
	sta out_page		
	
	
	ldy #$00
@gfx_m2:	
	lamy mem_page
	beq @gfx_m9
	cmp #$0d
	beq :+
	cmp #$0a
	beq	@gfx_m1
	tya
	pha
	lamy mem_page
	jsr gfx_plotchar
	pla
	tay
:	iny
	cmp	#$12
	bne @gfx_m2
@gfx_m3:	
	lamy mem_page
	beq @gfx_m9
	cmp #$0d
	beq :+
	cmp #$0a
	beq	@gfx_m1
:	iny
	bne @gfx_m3
;	beq @gfx_m9	;line to long
@gfx_m9:	
	pla
	rts


@gfx_m1:
	tya
	sec
	adc	sectorptr	
	sta	sectorptr	
	lda	sectorptr+1	
	adc #0
	sta	sectorptr+1	
	
	pla
	sec
	sbc	#1
	bne crtn_m0
	rts
	
	
;	.align 256
bootfont:
	.incbin "bootfont.bin"
